#!/bin/bash

# 下载文件
echo "正在下载dufs..."
wget https://fs.n1.tianyunperfect.cn:10086/2025/dufs-v0.43.0-x86_64-unknown-linux-musl.tar.gz

# 检查下载是否成功
if [ $? -ne 0 ]; then
    echo "下载失败，请检查网络连接或URL是否正确"
    exit 1
fi

# 解压文件
echo "正在解压..."
tar -xzf dufs-v0.43.0-x86_64-unknown-linux-musl.tar.gz

# 检查解压是否成功
if [ $? -ne 0 ]; then
    echo "解压失败，请检查文件是否完整"
    exit 1
fi

# 移动文件到/usr/local/bin
echo "正在移动dufs到/usr/local/bin..."
sudo mv dufs /usr/local/bin/

# 检查移动是否成功
if [ $? -ne 0 ]; then
    echo "移动失败，请检查权限或目标目录是否存在"
    exit 1
fi

# 清理临时文件
echo "清理临时文件..."
rm dufs-v0.43.0-x86_64-unknown-linux-musl.tar.gz

echo "操作完成！dufs已成功安装到/usr/local/bin"